Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 1 | #!/bin/echo ERROR: This script needs to be sourced. Please run as . |
| 2 | |
| 3 | # toaster - shell script to start Toaster |
| 4 | |
| 5 | # Copyright (C) 2013-2015 Intel Corp. |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 6 | |
| 7 | # This program is free software; you can redistribute it and/or modify |
| 8 | # it under the terms of the GNU General Public License as published by |
| 9 | # the Free Software Foundation; either version 2 of the License, or |
| 10 | # (at your option) any later version. |
| 11 | # |
| 12 | # This program is distributed in the hope that it will be useful, |
| 13 | # but WITHOUT ANY WARRANTY; without even the implied warranty of |
| 14 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| 15 | # GNU General Public License for more details. |
| 16 | # |
| 17 | # You should have received a copy of the GNU General Public License |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 18 | # along with this program. If not, see http://www.gnu.org/licenses/. |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 19 | |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 20 | HELP=" |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 21 | Usage: source toaster start|stop [webport=<address:port>] [noweb] [nobuild] |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 22 | Optional arguments: |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 23 | [nobuild] Setup the environment for capturing builds with toaster but disable managed builds |
| 24 | [noweb] Setup the environment for capturing builds with toaster but don't start the web server |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 25 | [webport] Set the development server (default: localhost:8000) |
| 26 | " |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 27 | |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 28 | custom_extention() |
| 29 | { |
| 30 | custom_extension=$BBBASEDIR/lib/toaster/orm/fixtures/custom_toaster_append.sh |
| 31 | if [ -f $custom_extension ] ; then |
| 32 | $custom_extension $* |
| 33 | fi |
| 34 | } |
| 35 | |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 36 | databaseCheck() |
| 37 | { |
| 38 | retval=0 |
| 39 | # you can always add a superuser later via |
| 40 | # ../bitbake/lib/toaster/manage.py createsuperuser --username=<ME> |
| 41 | $MANAGE migrate --noinput || retval=1 |
| 42 | |
| 43 | if [ $retval -eq 1 ]; then |
| 44 | echo "Failed migrations, aborting system start" 1>&2 |
| 45 | return $retval |
| 46 | fi |
| 47 | # Make sure that checksettings can pick up any value for TEMPLATECONF |
| 48 | export TEMPLATECONF |
| 49 | $MANAGE checksettings --traceback || retval=1 |
| 50 | |
| 51 | if [ $retval -eq 1 ]; then |
| 52 | printf "\nError while checking settings; aborting\n" |
| 53 | return $retval |
| 54 | fi |
| 55 | |
| 56 | return $retval |
| 57 | } |
| 58 | |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 59 | webserverKillAll() |
| 60 | { |
| 61 | local pidfile |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 62 | if [ -f ${BUILDDIR}/.toastermain.pid ] ; then |
| 63 | custom_extention web_stop_postpend |
| 64 | else |
| 65 | custom_extention noweb_stop_postpend |
| 66 | fi |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 67 | for pidfile in ${BUILDDIR}/.toastermain.pid ${BUILDDIR}/.runbuilds.pid; do |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 68 | if [ -f ${pidfile} ]; then |
| 69 | pid=`cat ${pidfile}` |
| 70 | while kill -0 $pid 2>/dev/null; do |
Brad Bishop | 316dfdd | 2018-06-25 12:45:53 -0400 | [diff] [blame] | 71 | kill -SIGTERM $pid 2>/dev/null |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 72 | sleep 1 |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 73 | done |
| 74 | rm ${pidfile} |
| 75 | fi |
| 76 | done |
| 77 | } |
| 78 | |
| 79 | webserverStartAll() |
| 80 | { |
| 81 | # do not start if toastermain points to a valid process |
| 82 | if ! cat "${BUILDDIR}/.toastermain.pid" 2>/dev/null | xargs -I{} kill -0 {} ; then |
| 83 | retval=1 |
| 84 | rm "${BUILDDIR}/.toastermain.pid" |
| 85 | fi |
| 86 | |
| 87 | retval=0 |
Patrick Williams | f1e5d69 | 2016-03-30 15:21:19 -0500 | [diff] [blame] | 88 | |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 89 | # check the database |
| 90 | databaseCheck || return 1 |
Patrick Williams | f1e5d69 | 2016-03-30 15:21:19 -0500 | [diff] [blame] | 91 | |
| 92 | echo "Starting webserver..." |
| 93 | |
Brad Bishop | 316dfdd | 2018-06-25 12:45:53 -0400 | [diff] [blame] | 94 | $MANAGE runserver --noreload "$ADDR_PORT" \ |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 95 | </dev/null >>${BUILDDIR}/toaster_web.log 2>&1 \ |
| 96 | & echo $! >${BUILDDIR}/.toastermain.pid |
Patrick Williams | f1e5d69 | 2016-03-30 15:21:19 -0500 | [diff] [blame] | 97 | |
| 98 | sleep 1 |
| 99 | |
| 100 | if ! cat "${BUILDDIR}/.toastermain.pid" | xargs -I{} kill -0 {} ; then |
| 101 | retval=1 |
| 102 | rm "${BUILDDIR}/.toastermain.pid" |
| 103 | else |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 104 | echo "Toaster development webserver started at http://$ADDR_PORT" |
| 105 | echo -e "\nYou can now run 'bitbake <target>' on the command line and monitor your build in Toaster.\nYou can also use a Toaster project to configure and run a build.\n" |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 106 | custom_extention web_start_postpend $ADDR_PORT |
Patrick Williams | f1e5d69 | 2016-03-30 15:21:19 -0500 | [diff] [blame] | 107 | fi |
| 108 | |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 109 | return $retval |
| 110 | } |
| 111 | |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 112 | INSTOPSYSTEM=0 |
| 113 | |
| 114 | # define the stop command |
| 115 | stop_system() |
| 116 | { |
| 117 | # prevent reentry |
| 118 | if [ $INSTOPSYSTEM -eq 1 ]; then return; fi |
| 119 | INSTOPSYSTEM=1 |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 120 | webserverKillAll |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 121 | # unset exported variables |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 122 | unset TOASTER_DIR |
| 123 | unset BITBAKE_UI |
| 124 | unset BBBASEDIR |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 125 | trap - SIGHUP |
| 126 | #trap - SIGCHLD |
| 127 | INSTOPSYSTEM=0 |
| 128 | } |
| 129 | |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 130 | verify_prereq() { |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 131 | # Verify Django version |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 132 | reqfile=$(python3 -c "import os; print(os.path.realpath('$BBBASEDIR/toaster-requirements.txt'))") |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 133 | exp='s/Django\([><=]\+\)\([^,]\+\),\([><=]\+\)\(.\+\)/' |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 134 | # expand version parts to 2 digits to support 1.10.x > 1.8 |
| 135 | # (note:helper functions hard to insert in-line) |
| 136 | exp=$exp'import sys,django;' |
| 137 | exp=$exp'version=["%02d" % int(n) for n in django.get_version().split(".")];' |
| 138 | exp=$exp'vmin=["%02d" % int(n) for n in "\2".split(".")];' |
| 139 | exp=$exp'vmax=["%02d" % int(n) for n in "\4".split(".")];' |
| 140 | exp=$exp'sys.exit(not (version \1 vmin and version \3 vmax))' |
| 141 | exp=$exp'/p' |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 142 | if ! sed -n "$exp" $reqfile | python3 - ; then |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 143 | req=`grep ^Django $reqfile` |
| 144 | echo "This program needs $req" |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 145 | echo "Please install with pip3 install -r $reqfile" |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 146 | return 2 |
| 147 | fi |
| 148 | |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 149 | return 0 |
| 150 | } |
| 151 | |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 152 | # read command line parameters |
| 153 | if [ -n "$BASH_SOURCE" ] ; then |
| 154 | TOASTER=${BASH_SOURCE} |
| 155 | elif [ -n "$ZSH_NAME" ] ; then |
| 156 | TOASTER=${(%):-%x} |
| 157 | else |
| 158 | TOASTER=$0 |
| 159 | fi |
| 160 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 161 | export BBBASEDIR=`dirname $TOASTER`/.. |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 162 | MANAGE="python3 $BBBASEDIR/lib/toaster/manage.py" |
| 163 | OE_ROOT=`dirname $TOASTER`/../.. |
Patrick Williams | f1e5d69 | 2016-03-30 15:21:19 -0500 | [diff] [blame] | 164 | |
Patrick Williams | f1e5d69 | 2016-03-30 15:21:19 -0500 | [diff] [blame] | 165 | # this is the configuraton file we are using for toaster |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 166 | # we are using the same logic that oe-setup-builddir uses |
| 167 | # (based on TEMPLATECONF and .templateconf) to determine |
| 168 | # which toasterconf.json to use. |
| 169 | # note: There are a number of relative path assumptions |
| 170 | # in the local layers that currently make using an arbitrary |
| 171 | # toasterconf.json difficult. |
| 172 | |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 173 | . $OE_ROOT/.templateconf |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 174 | if [ -n "$TEMPLATECONF" ]; then |
| 175 | if [ ! -d "$TEMPLATECONF" ]; then |
| 176 | # Allow TEMPLATECONF=meta-xyz/conf as a shortcut |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 177 | if [ -d "$OE_ROOT/$TEMPLATECONF" ]; then |
| 178 | TEMPLATECONF="$OE_ROOT/$TEMPLATECONF" |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 179 | fi |
| 180 | fi |
| 181 | fi |
| 182 | |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 183 | unset OE_ROOT |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 184 | |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 185 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 186 | WEBSERVER=1 |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 187 | export TOASTER_BUILDSERVER=1 |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 188 | ADDR_PORT="localhost:8000" |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 189 | unset CMD |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 190 | for param in $*; do |
| 191 | case $param in |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 192 | noweb ) |
| 193 | WEBSERVER=0 |
| 194 | ;; |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 195 | nobuild ) |
| 196 | TOASTER_BUILDSERVER=0 |
| 197 | ;; |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 198 | start ) |
| 199 | CMD=$param |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 200 | ;; |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 201 | stop ) |
| 202 | CMD=$param |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 203 | ;; |
| 204 | webport=*) |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 205 | ADDR_PORT="${param#*=}" |
| 206 | # Split the addr:port string |
| 207 | ADDR=`echo $ADDR_PORT | cut -f 1 -d ':'` |
| 208 | PORT=`echo $ADDR_PORT | cut -f 2 -d ':'` |
| 209 | # If only a port has been speified then set address to localhost. |
| 210 | if [ $ADDR = $PORT ] ; then |
| 211 | ADDR_PORT="localhost:$PORT" |
| 212 | fi |
| 213 | ;; |
| 214 | --help) |
| 215 | echo "$HELP" |
| 216 | return 0 |
| 217 | ;; |
| 218 | *) |
| 219 | echo "$HELP" |
| 220 | return 1 |
| 221 | ;; |
| 222 | |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 223 | esac |
| 224 | done |
| 225 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 226 | if [ `basename \"$0\"` = `basename \"${TOASTER}\"` ]; then |
| 227 | echo "Error: This script needs to be sourced. Please run as . $TOASTER" |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 228 | return 1 |
| 229 | fi |
| 230 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 231 | verify_prereq || return 1 |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 232 | |
| 233 | # We make sure we're running in the current shell and in a good environment |
| 234 | if [ -z "$BUILDDIR" ] || ! which bitbake >/dev/null 2>&1 ; then |
| 235 | echo "Error: Build environment is not setup or bitbake is not in path." 1>&2 |
| 236 | return 2 |
| 237 | fi |
| 238 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 239 | # this defines the dir toaster will use for |
| 240 | # 1) clones of layers (in _toaster_clones ) |
| 241 | # 2) the build dir (in build) |
| 242 | # 3) the sqlite db if that is being used. |
| 243 | # 4) pid's we need to clean up on exit/shutdown |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 244 | export TOASTER_DIR=`dirname $BUILDDIR` |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 245 | export BB_ENV_EXTRAWHITE="$BB_ENV_EXTRAWHITE TOASTER_DIR" |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 246 | |
| 247 | # Determine the action. If specified by arguments, fine, if not, toggle it |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 248 | if [ "$CMD" = "start" ] ; then |
| 249 | if [ -n "$BBSERVER" ]; then |
| 250 | echo " Toaster is already running. Exiting..." |
| 251 | return 1 |
| 252 | fi |
| 253 | elif [ "$CMD" = "" ]; then |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 254 | echo "No command specified" |
| 255 | echo "$HELP" |
| 256 | return 1 |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 257 | fi |
| 258 | |
| 259 | echo "The system will $CMD." |
| 260 | |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 261 | # Execute the commands |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 262 | custom_extention toaster_prepend $CMD $ADDR_PORT |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 263 | |
| 264 | case $CMD in |
| 265 | start ) |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 266 | # check if addr:port is not in use |
| 267 | if [ "$CMD" == 'start' ]; then |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 268 | if [ $WEBSERVER -gt 0 ]; then |
| 269 | $MANAGE checksocket "$ADDR_PORT" || return 1 |
| 270 | fi |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 271 | fi |
| 272 | |
| 273 | # Create configuration file |
| 274 | conf=${BUILDDIR}/conf/local.conf |
| 275 | line='INHERIT+="toaster buildhistory"' |
| 276 | grep -q "$line" $conf || echo $line >> $conf |
| 277 | |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 278 | if [ $WEBSERVER -eq 0 ] ; then |
| 279 | # Do not update the database for "noweb" unless |
| 280 | # it does not yet exist |
| 281 | if [ ! -f "$TOASTER_DIR/toaster.sqlite" ] ; then |
| 282 | if ! databaseCheck; then |
| 283 | echo "Failed ${CMD}." |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 284 | return 4 |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 285 | fi |
| 286 | fi |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 287 | custom_extention noweb_start_postpend $ADDR_PORT |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 288 | fi |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 289 | if [ $WEBSERVER -gt 0 ] && ! webserverStartAll; then |
| 290 | echo "Failed ${CMD}." |
| 291 | return 4 |
| 292 | fi |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 293 | export BITBAKE_UI='toasterui' |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 294 | if [ $TOASTER_BUILDSERVER -eq 1 ] ; then |
| 295 | $MANAGE runbuilds \ |
| 296 | </dev/null >>${BUILDDIR}/toaster_runbuilds.log 2>&1 \ |
| 297 | & echo $! >${BUILDDIR}/.runbuilds.pid |
| 298 | else |
| 299 | echo "Toaster build server not started." |
| 300 | fi |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 301 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 302 | # set fail safe stop system on terminal exit |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 303 | trap stop_system SIGHUP |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 304 | echo "Successful ${CMD}." |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 305 | custom_extention toaster_postpend $CMD $ADDR_PORT |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 306 | return 0 |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 307 | ;; |
| 308 | stop ) |
| 309 | stop_system |
| 310 | echo "Successful ${CMD}." |
| 311 | ;; |
| 312 | esac |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 313 | custom_extention toaster_postpend $CMD $ADDR_PORT |
| 314 | |